//MicroPistol.cs

//audio
datablock AudioProfile(MicroPistolShot1Sound)
{
   filename    = "./NerfFire.wav";
   description = AudioClose3d;
   preload = true;
};
datablock AudioProfile(MicroPistolBulletHitSound)
{
   filename    = "./bulletHit.wav";
   description = AudioClose3d;
   preload = true;
};
datablock AudioProfile(MicroPistolCockSound)
{
   filename    = "./NerfCock.wav";
   description = AudioClose3d;
   preload = true;
};

datablock ExplosionData(MicroPistolExplosion)
{
   //explosionShape = "";
	soundProfile = MicroPistolBulletHitSound;

   lifeTimeMS = 150;

   faceViewer     = true;
   explosionScale = "1 1 1";

};


AddDamageType("MicroPistol",   '<bitmap:add-ons/Weapon_NerfMicroPistol/CI_MicroPistol> %1',    '%2 <bitmap:add-ons/Weapon_NerfMicroPistol/CI_MicroPistol> %1',0.2,1);
datablock ProjectileData(MicroPistolProjectile)
{
   projectileShapeName = "./Dart.dts";
   directDamage        = 4;
   directDamageType    = $DamageType::MicroPistol;
   radiusDamageType    = $DamageType::MicroPistol;

   brickExplosionRadius = 0;
   brickExplosionImpact = false;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 0;
   brickExplosionMaxVolume = 0;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 0;  //max volume of bricks that we can destroy if they aren't connected to the ground

      explosion             = MicroPistolExplosion;
   stickExplosion        = MicroPistolExplosion;
   bloodExplosion        = MicroPistolExplosion;
   particleEmitter       = MicroPistolEmitter;
   explodeOnPlayerImpact = true;
   explodeOnDeath        = true;  

   armingDelay         = 1000;
   lifetime            = 4000;
   fadeDelay           = 1000;

   isBallistic         = true;
   bounceAngle         = 170; //stick almost all the time
   minStickVelocity    = 10;
   bounceElasticity    = 0.2;
   bounceFriction      = 0.01;   
   gravityMod = 0.25;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";

   muzzleVelocity      = 65;
   velInheritFactor    = 1;

   uiName = "Nerf Dart";

};

//////////
// item //
//////////
datablock ItemData(MicroPistolItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./nerfpistol.dts";
	rotate = false;
	mass = 1;
	density = 0.5;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Micro-Pistol";
	iconName = "./Icon_MicroPistol";
	doColorShift = true;
	colorShiftColor = "0.25 0.25 0.25 1.000";

	 // Dynamic properties defined by the scripts
	image = MicroPistolImage;
	canDrop = true;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(MicroPistolImage)
{
   // Basic Item properties
   shapeFile = "./nerfpistol.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = BowItem;
   ammo = " ";
   projectile = MicroPistolProjectile;
   projectileType = Projectile;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   doColorShift = true;
   colorShiftColor = MicroPistolItem.colorShiftColor;//"0.400 0.196 0 1.000";

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.1;
	stateTransitionOnTimeout[0]       = "Ready";
	stateSound[0]					= weaponSwitchSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "Fire";
	stateAllowImageChange[1]         = true;
	stateSequence[1]	= "Ready";

	stateName[2]                    = "Fire";
	stateTransitionOnTimeout[2]     = "Reload";
	stateTimeoutValue[2]            = 0.1;
	stateFire[2]                    = true;
	stateAllowImageChange[2]        = false;
	stateSequence[2]                = "Fire";
	stateScript[2]                  = "onFire";
	stateWaitForTimeout[2]			= true;
	stateSound[2]					= MicroPistolShot1Sound;

	stateName[4]			= "Reload";
	stateSequence[4]                = "Reload";
	stateTransitionOnTimeout[4]     = "Reload2";
	stateSound[4]					= MicroPistolCockSound;
	stateTimeoutValue[4]            = 0.1;

	stateName[5]			= "Reload2";
	stateSequence[5]                = "Ready";
	stateTransitionOnTriggerUp[5]     = "Ready";
	stateTimeoutValue[5]            = 0.1;

};

function MicroPistolImage::onFire(%this,%obj,%slot)
{
	if(%obj.getDamagePercent() < 1.0)
		%obj.playThread(2, shiftAway);
	Parent::onFire(%this,%obj,%slot);	
}
